<template>
  <div class="report text-center">
    <h1>Report</h1>
    <p>Reporting tests with {{ title }} is <b>easy</b>!</p>

    <Loading :loading="this.$apollo.queries.systems.loading" />

    <div v-if="!this.$apollo.queries.systems.loading">
      <h2>First, select a system to test</h2>
      <p>
        Systems represent a piece of software or a service that can be tested.
      </p>
      <b-card-group columns>
        <b-card
          v-for="(system, id) in systems"
          v-bind:key="id"
          :img-src="system.image || 'https://picsum.photos/600/300/?image=25'"
          :img-alt="`${system.name} preview image`"
          img-top
          style="max-width: 20rem;"
          class="mb-2"
          :bg-variant="system.id == run.system ? 'primary' : 'light'"
          :text-variant="system.id == run.system ? 'white' : 'black'"
          @click="
            run.system = system.id;
            run.build = null;
            run.test = null;
            systemSelected();
          "
        >
          <b-card-title>{{ system.name }}</b-card-title>

          <b-card-text>
            {{ system.description }}
          </b-card-text>
        </b-card>
      </b-card-group>

      <h2 ref="builds" v-show="run.system">
        Select build of {{ selectedSystem.name }}...
      </h2>
      <p v-show="run.system">
        Builds represent versions of the system.
        {{
          selectableChannels.length > 1
            ? "Builds can be organized in channels to enable parallel development."
            : ""
        }}
      </p>
      <p v-show="run.system && !selectableChannels.length">
        There are no builds to test...
      </p>
      <b-tabs
        content-class="mt-3"
        align="center"
        :nav-wrapper-class="selectableChannels.length === 1 ? 'hidden' : ''"
        v-show="selectableChannels.length"
      >
        <template v-slot:tabs-start>
          <li
            role="presentation"
            class="nav-item align-self-center"
            style="margin-right: 1rem"
          >
            <b>Channel:</b>
          </li>
        </template>
        <b-tab
          v-for="channel in selectableChannels"
          v-bind:key="channel.channel"
          :title="channel.channel"
        >
          <b-card-group columns>
            <b-card
              v-for="(build, id) in channel.builds"
              v-bind:key="id"
              style="max-width: 20rem;"
              :class="`mb-2 ${build.highlight ? 'highlighted-card' : ''}`"
              no-body
              :bg-variant="build.id == run.build ? 'primary' : 'light'"
              :text-variant="build.id == run.build ? 'white' : 'black'"
              @click="
                run.build = build.id;
                buildSelected();
              "
            >
              <b-card-body>
                <b-card-title>{{ build.tag }}</b-card-title>

                <b-card-text>
                  Released on
                  {{ new Date(Number(build.date)).toLocaleString() }}
                </b-card-text>
              </b-card-body>

              <b-card-footer class="report-card-progress-footer">
                <Status :status="build.status" />
              </b-card-footer>
            </b-card>
          </b-card-group>
        </b-tab>
      </b-tabs>

      <h2 ref="tests" v-show="run.system">...and a test you want to run</h2>
      <p v-show="run.system">
        Tests describe specific steps you need to take to confirm a specific
        component or feature of the system is working correctly in this build.
      </p>
      <p v-show="run.build && !selectableTests.length">
        There are no tests to run...
      </p>
      <b-tabs
        content-class="mt-3"
        align="center"
        :nav-wrapper-class="selectableTestGroups.length === 1 ? 'hidden' : ''"
        v-show="selectableTests.length"
      >
        <template v-slot:tabs-start>
          <li
            role="presentation"
            class="nav-item align-self-center"
            style="margin-right: 1rem"
          >
            <b>Group:</b>
          </li>
        </template>
        <b-tab v-if="selectableTestGroups.length > 1" title="all" active>
          <b-card-group columns>
            <b-card
              v-for="(test, id) in selectableTests"
              v-bind:key="id"
              style="max-width: 20rem;"
              :class="`mb-2 ${test.highlight ? 'highlighted-card' : ''}`"
              no-body
              :bg-variant="test.test.id === run.test ? 'primary' : 'light'"
              :text-variant="test.test.id === run.test ? 'white' : 'black'"
              @click="
                run.test = test.test.id;
                testSelected();
              "
            >
              <b-card-body>
                <b-card-title>{{ test.test.name }}</b-card-title>
                <b-card-text>
                  Weight: {{ test.test.weight }}<br />
                  {{ test.test.description }}
                </b-card-text>
              </b-card-body>
              <b-card-footer class="report-card-progress-footer">
                <Status :status="test.status" />
              </b-card-footer>
            </b-card>
          </b-card-group>
        </b-tab>
        <b-tab
          v-for="group in selectableTestGroups"
          v-bind:key="group"
          :title="group"
        >
          <b-card-group columns>
            <b-card
              v-for="(test, id) in selectableTests.filter(
                test => test.test.group === group
              )"
              v-bind:key="id"
              style="max-width: 20rem;"
              :class="`mb-2 ${test.highlight ? 'highlighted-card' : ''}`"
              no-body
              :bg-variant="test.test.id === run.test ? 'primary' : 'light'"
              :text-variant="test.test.id === run.test ? 'white' : 'black'"
              @click="
                run.test = test.test.id;
                testSelected();
              "
            >
              <b-card-body>
                <b-card-title>{{ test.test.name }}</b-card-title>
                <b-card-text>
                  Weight: {{ test.test.weight }}<br />
                  {{ test.test.description }}
                </b-card-text>
              </b-card-body>
              <b-card-footer class="report-card-progress-footer">
                <Status :status="test.status" />
              </b-card-footer>
            </b-card>
          </b-card-group>
        </b-tab>
      </b-tabs>

      <div ref="run" v-show="selectedTest.name" class="text-left">
        <h2>
          Last but not least: Run the test "{{ selectedTest.name }}" on
          {{ selectedSystem.name }} ({{ selectedBuildTag }})
        </h2>
        <b-form>
          <b-form-group
            label-cols-sm="2"
            label="Test Description"
            label-for="description"
          >
            <p style="padding-top: calc(0.375rem + 1px)">
              {{ selectedTest.description }}
            </p>
          </b-form-group>

          <b-form-group
            label-cols-sm="2"
            label="Steps"
            label-for="steps"
            v-if="selectedTest.steps"
          >
            <p style="white-space: pre-line; padding-top: calc(0.375rem + 1px)">
              {{ selectedTest.steps }}
            </p>
          </b-form-group>

          <b-form-group
            v-for="property in selectedSystem.properties"
            v-bind:key="`property-input-${property.name}`"
            label-cols-sm="2"
            :label="property.name"
            :label-for="`property-input-${property.name}`"
          >
            <template v-slot:description>
              {{ property.description }}
              <a
                :href="property.link"
                target="_blank"
                rel="noreferrer noopener"
                v-show="property.link"
              >
                <b-icon-question-circle-fill />
              </a>
            </template>
            <!--
          <b-form-input
            v-if="property.values.length == 0"
            :id="`property-input-${property.name}`"
            v-model="run.combination[property.name]"
            :placeholder="property.description"
            trim
          />
          <b-form-checkbox
            v-if="
              property.values.length == 2 &&
                (property.values[0] === 'true' ||
                  property.values[0] === 'false')
            "
            :id="`property-input-${property.name}`"
            v-model="run.combination[property.name]"
          />
          -->
            <b-form-select
              :id="`property-input-${property.name}`"
              v-model="run.combination[property.name]"
              :options="property.values"
            />
          </b-form-group>

          <b-form-group
            label-cols-sm="2"
            description="Anything else the maintainers should know"
            label="Comment"
            label-for="comment"
          >
            <b-form-textarea
              id="comment"
              v-model="run.comment"
              placeholder="Everything works!"
              trim
            />
          </b-form-group>

          <b-form-group label-cols-sm="2" label="Logs" label-for="logs">
            <template v-slot:description>
              Logs are automatically generated text files containing debugging
              information
              <a
                :href="selectedSystem.logLink"
                target="_blank"
                rel="noreferrer noopener"
                v-show="selectedSystem.logLink"
              >
                <b-icon-question-circle-fill />
              </a>
            </template>
            <div
              v-for="(paste, pasteIndex) in run.logs.pastes"
              v-bind:key="`paste-${pasteIndex}`"
              style="margin-bottom: 1rem"
            >
              <b-input-group style="margin-bottom: .5rem">
                <b-form-input
                  :id="`log-${pasteIndex}-name`"
                  v-model="run.logs.pastes[pasteIndex].name"
                  :placeholder="`Log ${pasteIndex} name`"
                  trim
                />
                <b-input-group-append>
                  <b-button
                    @click="run.logs.pastes.splice(pasteIndex, 1)"
                    variant="danger"
                    aria-label="Remove pasted log"
                  >
                    <b-icon-trash />
                  </b-button>
                </b-input-group-append>
              </b-input-group>
              <b-form-textarea
                :id="`log-${pasteIndex}-content`"
                v-model="run.logs.pastes[pasteIndex].content"
                :placeholder="`Paste log ${pasteIndex} here...`"
                trim
              />
            </div>

            <b-input-group
              v-for="(file, fileIndex) in run.logs.files"
              v-bind:key="`file-${fileIndex}`"
              style="margin-bottom: 1rem"
            >
              <b-form-file
                :id="`logfile-${fileIndex}`"
                v-model="run.logs.files[fileIndex]"
                :placeholder="`Log file ${fileIndex}`"
                accept="text"
              />
              <b-input-group-append>
                <b-button
                  @click="run.logs.files.splice(fileIndex, 1)"
                  variant="danger"
                  aria-label="Remove log file"
                >
                  <b-icon-trash />
                </b-button>
              </b-input-group-append>
            </b-input-group>

            <b-button-group id="logs">
              <b-button @click="run.logs.files.push(null)">
                <b-icon-file-earmark-text />
                Add log file
              </b-button>
              <b-button
                @click="run.logs.pastes.push({ name: null, content: null })"
              >
                <b-icon-text-left />
                Add pasted log
              </b-button>
            </b-button-group>
          </b-form-group>

          <b-form-group
            label-cols-sm="2"
            description="Select a test result and submit"
            label="Submit result"
            label-for="result"
          >
            <b-button-group size="lg" id="result">
              <b-button
                variant="success"
                @click="submit('PASS')"
                v-b-tooltip.hover
                :title="`Test passed`"
                :disabled="!valid"
              >
                <b-icon-plus-circle-fill />
                PASS
              </b-button>
              <b-button
                variant="warning"
                @click="submit('WONKY')"
                v-b-tooltip.hover
                :title="`Test passed with workarounds`"
                :disabled="!valid"
              >
                <b-icon-exclamation-circle-fill />
                WONKY
              </b-button>
              <b-button
                variant="danger"
                @click="submit('FAIL')"
                v-b-tooltip.hover
                :title="`Test failed`"
                :disabled="!valid"
              >
                <b-icon-dash-circle-fill />
                FAIL
              </b-button>
            </b-button-group>
          </b-form-group>
        </b-form>
        <p v-show="!valid" style="color: red;">
          Please specify your system properties!
        </p>
      </div>
    </div>
    <p style="color: red;">{{ error }}</p>

    <b-modal
      title="Done! What's next?"
      :visible="Boolean(lastRunId)"
      ok-title="View run"
      ok-variant="success"
      cancel-title="Run another test"
      cancel-variant="primary"
      @ok="viewRun"
      @cancel="runAnother"
    >
      <p class="my-4">
        Your run was successfully submitted. Do you want to examine it or run
        another test?
      </p>
    </b-modal>
  </div>
</template>

<script>
import Status from "@/components/Status.vue";
import Loading from "@/components/Loading.vue";
import gql from "graphql-tag";

export default {
  name: "Report",
  computed: {
    valid: function() {
      return (
        this.selectedSystem &&
        this.selectedSystem?.properties?.length ===
          Object.keys(this.run?.combination)?.length
      );
    },
    selectedSystem: function() {
      return this.run.system && this.systems.length
        ? this.systems.find(s => s.id == this.run.system)
        : { name: "the system" };
    },
    selectedBuildTag: function() {
      return this.run.system &&
        this.run.build &&
        this.run.test &&
        this.systems.length
        ? this.systems
            .find(s => s.id == this.run.system)
            .builds.find(b => b.id == this.run.build).tag
        : "";
    },
    selectableTestGroups: function() {
      return [...new Set(this.selectableTests.map(test => test.test.group))];
    },
    selectableTests: function() {
      return this.run.system && this.run.build && this.systems.length
        ? this.systems
            .find(s => s.id == this.run.system)
            .builds.find(b => b.id == this.run.build).tests
        : [];
    },
    selectableChannels: function() {
      return this.run.system && this.systems.length
        ? this.systems.find(s => s.id == this.run.system).channels
        : [];
    },
    selectedTest: function() {
      return (
        this.selectableTests.find(s => s.test.id === this.run.test)?.test || {}
      );
    }
  },
  data() {
    return {
      title: process.env.VUE_APP_TITLE || "OPEN-CUTS",
      systems: [],
      run: {
        system: this.$route.query.system || null,
        build: this.$route.query.build || null,
        test: this.$route.query.test || null,
        combination: {},
        logs: {
          files: [],
          pastes: []
        }
      },
      error: "",
      lastRunId: false
    };
  },
  apollo: {
    systems: {
      query: gql`
        query {
          systems {
            id
            name
            description
            image
            logLink
            properties {
              name
              description
              link
              values
            }
            builds {
              id
              tag
              tests {
                highlight
                status {
                  pass
                  wonky
                  fail
                  inconclusive
                }
                test {
                  id
                  name
                  group
                  description
                  steps
                  weight
                }
              }
            }
            channels {
              channel
              builds {
                id
                tag
                date
                highlight
                status {
                  pass
                  wonky
                  fail
                  inconclusive
                }
              }
            }
          }
        }
      `,
      result() {
        if (this.$route.query.system) this.systemSelected();
      }
    }
  },
  methods: {
    systemSelected() {
      this.run.combination =
        JSON.parse(localStorage.getItem(`combination-${this.run.system}`)) ||
        {};
      setTimeout(() => this.$refs?.builds?.scrollIntoView(), 5);
    },
    buildSelected() {
      setTimeout(() => {
        if (this.selectableTests.length === 1) {
          this.run.test = this.selectableTests[0].test.id;
          this.testSelected();
        } else {
          this.$refs.tests.scrollIntoView();
        }
      }, 5);
    },
    testSelected() {
      setTimeout(() => this.$refs.run.scrollIntoView(), 5);
    },
    viewRun() {
      window.location.href = `/run/${this.lastRunId}`;
    },
    runAnother() {
      window.location.href = `/report?system=${this.selectedSystem?.id}&build=${this.run?.build}`;
    },
    async submit(result) {
      localStorage.setItem(
        `combination-${this.selectedSystem.id}`,
        JSON.stringify(this.run.combination)
      );
      this.getLogs().then(logs => {
        this.$apollo
          .mutate({
            mutation: gql`
              mutation($buildId: ID!, $testId: ID!, $run: RunInput!) {
                createRun(buildId: $buildId, testId: $testId, run: $run) {
                  id
                }
              }
            `,
            variables: {
              buildId: this.run.build,
              testId: this.run.test,
              run: {
                result,
                comment: this.run.comment || undefined,
                logs: logs,
                combination: Object.entries(this.run.combination).map(o => ({
                  variable: o[0],
                  value: String(o[1])
                }))
              }
            }
          })
          .then(data => (this.lastRunId = data.data.createRun.id))
          .catch(error => (this.error = error));
      });
    },
    async getLogs() {
      return Promise.all(
        this.run.logs.files.map(f =>
          f.text().then(content => ({
            name: f.name,
            content
          }))
        )
      ).then(logs =>
        logs.concat(
          this.run.logs.pastes.map(p => ({
            name: p.name,
            content: p.content
          }))
        )
      );
    }
  },
  components: {
    Status,
    Loading
  }
};
</script>
